Subject: Re: Coverity: nouveau_dp_irq(): Null pointer dereferences

From: Jani Nikula <[email-masked]>
Date: Mon, 14 Nov 2022 12:07:55 +0200

On Fri, 11 Nov 2022, Karol Herbst <[email-masked]> wrote:
> On Fri, Nov 11, 2022 at 9:16 PM Kees Cook <[email-masked]> wrote:
>>
>> On Fri, Nov 11, 2022 at 09:06:54PM +0100, Karol Herbst wrote:
>> > On Fri, Nov 11, 2022 at 8:21 PM Kees Cook <[email-masked]> wrote:
>> > >
>> > > On Fri, Nov 11, 2022 at 11:13:17AM +0200, Jani Nikula wrote:
>> > > > On Thu, 10 Nov 2022, coverity-bot <[email-masked]> wrote:
>> > > > > Hello!
>> > > > >
>> > > > > This is an experimental semi-automated report about issues detected by
>> > > > > Coverity from a scan of next-20221110 as part of the linux-next scan project:
>> > > > > https://scan.coverity.com/projects/linux-next-weekly-scan
>> > > > >
>> > > > > You're getting this email because you were associated with the identified
>> > > > > lines of code (noted below) that were touched by commits:
>> > > > >
>> > > > >   Mon Aug 31 19:10:08 2020 -0400
>> > > > >     a0922278f83e ("drm/nouveau/kms/nv50-: Refactor and cleanup DP HPD handling")
>> > > >
>> > > > Hi Kees, this looks like a good idea, but maybe double check the Cc list
>> > > > generation? I was Cc'd on four mails today that I thought were
>> > > > irrelevant to me.
>> > >
>> > > Hi!
>> > >
>> > > Heh, I was recently asked to _expand_ the CC list. :)
>> > >
>> > > For these last pass of reports, I added a get_maintainers.pl run to the
>> > > identified commit. In this instance, the commit touched:
>> > >
>> > >  drivers/gpu/drm/nouveau/dispnv04/disp.c     |    6 +
>> > >  drivers/gpu/drm/nouveau/dispnv50/disp.c     |  192 ++++++++++++++++++++++--------------------------
>> > >  drivers/gpu/drm/nouveau/nouveau_connector.c |   14 ---
>> > >  drivers/gpu/drm/nouveau/nouveau_display.c   |    2
>> > >  drivers/gpu/drm/nouveau/nouveau_display.h   |    2
>> > >  drivers/gpu/drm/nouveau/nouveau_dp.c        |  132 ++++++++++++++++++++++++++++-----
>> > >  drivers/gpu/drm/nouveau/nouveau_encoder.h   |   33 +++++++-
>> > >  7 files changed, 244 insertions(+), 137 deletions(-)
>> > >
>> > > And the get_maintainers.pl rationale was:
>> > >
>> > > Ben Skeggs <[email-masked]> (supporter:DRM DRIVER FOR NVIDIA GEFORCE/QUADRO GPUS,commit_signer:1/1=100%,commit_signer:6/16=38%,authored:4/16=25%,added_lines:23/124=19%,removed_lines:36/152=24%)
>> > > Karol Herbst <[email-masked]> (supporter:DRM DRIVER FOR NVIDIA GEFORCE/QUADRO GPUS,commit_signer:2/1=100%)
>> > > Lyude Paul <[email-masked]> (supporter:DRM DRIVER FOR NVIDIA GEFORCE/QUADRO GPUS,commit_signer:9/16=56%,authored:6/16=38%,added_lines:92/124=74%,removed_lines:107/152=70%)
>> > > David Airlie <[email-masked]> (maintainer:DRM DRIVERS)
>> > > Daniel Vetter <[email-masked]> (maintainer:DRM DRIVERS)
>> > > Ilia Mirkin <[email-masked]> (commit_signer:1/1=100%,authored:1/1=100%,added_lines:2/2=100%,removed_lines:2/2=100%)
>> > > "Nathan E. Egge" <[email-masked]> (commit_signer:1/1=100%)
>> > > Jani Nikula <[email-masked]> (commit_signer:6/16=38%)
>> > > Dave Airlie <[email-masked]> (commit_signer:5/16=31%)
>> > > Thomas Zimmermann <[email-masked]> (commit_signer:4/16=25%,authored:4/16=25%)
>> > > [email-masked] (open list:DRM DRIVER FOR NVIDIA GEFORCE/QUADRO GPUS)
>> > > [email-masked] (open list:DRM DRIVER FOR NVIDIA GEFORCE/QUADRO GPUS)
>> > >
>> >
>> > I'd say it's good enough to message supporters and the mailing lists
>> > for at least Nouveau code, maybe even all drm drivers.
>>
>> i.e. leave out the commit_signer hits?
>>
>
> yes.

Agreed.

I understand the point of commit_signer, but I don't think
get_maintainers.pl does a very good job with the heuristics, or
filtering out "insignificant" contributions to the files being changed.

BR,
Jani.

>
>> > Not sure what to do about actual maintainers, but I doubt Dave and
>> > Daniel want to be CCed on every Coverity report here either.
>>
>> I updated the CC logic based on this feedback:
>> https://lore.kernel.org/linux-hardening/[email-masked]/
>>
>> So maybe just mailing lists?
>>
>
> That should be good enough, but maybe the DRM subsystem is big enough
> so it's reasonable to add special rules. For Nouveau either way is
> fine.
>
>> --
>> Kees Cook
>>
>

-- 
Jani Nikula, Intel Open Source Graphics Center